import { ApiPaged, Lister } from "./types";
import { BaseApiClient } from "./jsbaseclient_api";
export declare type ListerFieldFilter<T> = (v: unknown) => T[];
export declare class ListerImpl<T> implements Lister<T>, AsyncIterable<T> {
    err?: Error;
    offset: number;
    pageInfo: ApiPaged;
    subject: string;
    jsm: BaseApiClient;
    filter: ListerFieldFilter<T>;
    constructor(subject: string, filter: ListerFieldFilter<T>, jsm: BaseApiClient);
    next(): Promise<T[]>;
    [Symbol.asyncIterator](): AsyncGenerator<Awaited<T>, void, unknown>;
}
